=== modified file 'loggerhead/TODO'
--- loggerhead/TODO	2006-12-14 05:25:41 +0000
+++ loggerhead/TODO	2006-12-15 01:14:05 +0000
@@ -1,11 +1,28 @@
 
+=== BEFORE POSTING TO BZR.DEV ===
+* copy credits over from webserve/hgweb plugin.
+
+* in changelog view, "files modified" etc should be links
+
+* in revision view, "files modified" etc should have #-links "(jump to diff)"
+  next to them
+
+* put files/etc "buttons" links back in the page
+    inventory
+    annotate
+    atom
+
+
+=== other ===
+
 * maybe put this at the footer of each page:
     paramiko-dev, 419 revisions, 1133 days old
     first revision: Tue 2003-11-04 08:34:24 +0000
     latest revision: Sat 2006-12-02 18:33:34 -0800
     ...or somewhere.
+    ... does this really matter?
 
 * add back the search bar.
-
-* copy credits over from webserve/hgweb plugin.
+    -- should notice dotted-revnos and use that to jump.
+	-- also search by date should be simple.
 	
\ No newline at end of file

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2006-12-14 05:25:41 +0000
+++ loggerhead/controllers/__init__.py	2006-12-15 01:14:05 +0000
@@ -71,5 +71,9 @@
 # re-index every hour (for now -- maybe should be even longer?)
 index_freq = 3600
 
-turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=rebuild_cache)
+#turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=rebuild_cache)
+
+# for use in profiling the very-slow get_change() method:
+#h = util.get_history()
+#h._get_change_profiled(h.last_revid)
 

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2006-12-14 05:25:41 +0000
+++ loggerhead/controllers/changelog_ui.py	2006-12-15 01:14:05 +0000
@@ -66,20 +66,18 @@
             revlist, start_revid = h.get_navigation(start_revid, path)
             if revid is None:
                 revid = start_revid
+            if revid not in revlist:
+                # if the given revid is not in the revlist, use a revlist that
+                # starts at the given revid.
+                revlist, start_revid = h.get_navigation(revid, path)
             entry_list = list(h.get_revids_from(revlist, revid))[:pagesize]
             entries = h.get_changelist(entry_list)
         except Exception, x:
             log.error('Exception fetching changes: %r, %s' % (x, x))
             raise HTTPRedirect(turbogears.url('/changes'))
 
-        buttons = [
-            ('home', turbogears.url('/changes')),
-            ('files', turbogears.url([ '/files', revid ])),
-            ('feed', turbogears.url('/atom')),
-        ]
-
         navigation = util.Container(pagesize=pagesize, revid=revid, start_revid=start_revid, revlist=revlist,
-                                    path=path, buttons=buttons, scan_url='/changes')
+                                    path=path, scan_url='/changes', feed=True)
         next_page_revid = h.get_revlist_offset(revlist, revid, pagesize)
         prev_page_revid = h.get_revlist_offset(revlist, revid, -pagesize)
         

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2006-12-14 03:00:10 +0000
+++ loggerhead/controllers/revision_ui.py	2006-12-15 01:14:05 +0000
@@ -52,15 +52,9 @@
         except Exception, x:
             log.error('Exception fetching changes: %r, %s' % (x, x))
             raise HTTPRedirect(turbogears.url('/changes'))
-
-        buttons = [
-            ('top', turbogears.url('/changes')),
-            ('files', turbogears.url([ '/files', revid ])),
-            ('history', turbogears.url('/changes', start_revid=revid)),
-        ]
         
-        navigation = util.Container(buttons=buttons, revlist=revlist, revid=revid, start_revid=start_revid, path=path,
-                                    pagesize=1, scan_url='/revision')
+        navigation = util.Container(revlist=revlist, revid=revid, start_revid=start_revid, path=path,
+                                    pagesize=1, scan_url='/revision', feed=1)
         change = h.get_change(revid, get_diffs=True)
         
         next_revid = h.get_revlist_offset(revlist, revid, 1)

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2006-12-14 05:25:41 +0000
+++ loggerhead/history.py	2006-12-15 01:14:05 +0000
@@ -367,6 +367,16 @@
         
         return c
     
+    # alright, let's profile this sucka.
+    def _get_change_profiled(self, revid, get_diffs=False):
+        from loggerhead.lsprof import profile
+        import cPickle
+        ret, stats = profile(self._get_change, revid, get_diffs)
+        stats.sort()
+        stats.freeze()
+        cPickle.dump(stats, open('lsprof.stats', 'w'), 2)
+        return ret
+
     def _get_change(self, revid, get_diffs=False):
         try:
             rev = self._branch.repository.get_revision(revid)
@@ -426,29 +436,38 @@
         yield a list of (label, title, revid) for a scan range through the full
         branch history, centered around the given revid.
         
-        example: [ ('(425)', 'Latest', 'rrrr'), ('+1', 'Forward 1', 'rrrr'), ...
-                   ('-300', 'Back 300', 'rrrr'), ('(1)', 'Oldest', 'first-revid') ]
+        example: [ ('<<', 'Previous page', 'rrr'), ('-10', 'Forward 10', 'rrr'),
+                   ('*', None, None), ('+10', 'Back 10', 'rrr'),
+                   ('+30', 'Back 30', 'rrr'), ('>>', 'Next page', 'rrr') ]
+        
+        next/prev page are always using the pagesize.
         """
         count = len(revlist)
         pos = self.get_revid_sequence(revlist, revid)
-        if pos < count - 1:
-            yield ('<', 'Back %d' % (pagesize,),
-                   revlist[min(count - 1, pos + pagesize)])
+
+        if pos > 0:
+            yield (u'\xab', 'Previous page', revlist[max(0, pos - pagesize)])
         else:
-            yield ('<', None, None)
-        yield ('(1)', 'Oldest', revlist[-1])
-        for offset in reversed([-x for x in util.scan_range(pos, count)]):
+            yield (u'\xab', None, None)
+        
+        offset_sign = -1
+        for offset in util.scan_range(pos, count, pagesize):
+            if (offset > 0) and (offset_sign < 0):
+                offset_sign = 0
+                # show current position
+#                yield ('[%s]' % (self.get_revno(revlist[pos]),), None, None)
+#                yield (u'\u2022', None, None)
+                yield (u'\u00b7', None, None)
             if offset < 0:
                 title = 'Back %d' % (-offset,)
             else:
                 title = 'Forward %d' % (offset,)
-            yield ('%+d' % (offset,), title, revlist[pos - offset])
-        yield ('(%d)' % (len(revlist),) , 'Latest', revlist[0])
-        if pos > 0:
-            yield ('>', 'Forward %d' % (pagesize,),
-                   revlist[max(0, pos - pagesize)])
+            yield ('%+d' % (offset,), title, revlist[pos + offset])
+        
+        if pos < count - 1:
+            yield (u'\xbb', 'Next page', revlist[min(count - 1, pos + pagesize)])
         else:
-            yield ('>', None, None)
+            yield (u'\xbb', None, None)
     
     def get_revlist_offset(self, revlist, revid, offset):
         count = len(revlist)

=== added file 'loggerhead/lsprof.py'
--- loggerhead/lsprof.py	1970-01-01 00:00:00 +0000
+++ loggerhead/lsprof.py	2006-12-15 01:14:05 +0000
@@ -0,0 +1,192 @@
+# this is copied from the lsprof distro because somehow
+# it is not installed by distutils
+# I made one modification to profile so that it returns a pair
+# instead of just the Stats object
+
+import sys
+import thread
+import threading
+from _lsprof import Profiler, profiler_entry
+
+__all__ = ['profile', 'Stats']
+
+_g_threadmap = {}
+
+
+def _thread_profile(f, *args, **kwds):
+    # we lose the first profile point for a new thread in order to trampoline
+    # a new Profile object into place
+    global _g_threadmap
+    thr = thread.get_ident()
+    _g_threadmap[thr] = p = Profiler()
+    # this overrides our sys.setprofile hook:
+    p.enable(subcalls=True, builtins=True)
+
+
+def profile(f, *args, **kwds):
+    """XXX docstring"""
+    global _g_threadmap
+    p = Profiler()
+    p.enable(subcalls=True)
+    threading.setprofile(_thread_profile)
+    try:
+        ret = f(*args, **kwds)
+    finally:
+        p.disable()
+        for pp in _g_threadmap.values():
+            pp.disable()
+        threading.setprofile(None)
+    
+    threads = {}
+    for tid, pp in _g_threadmap.items():
+        threads[tid] = Stats(pp.getstats(), {})
+    _g_threadmap = {}
+    return ret, Stats(p.getstats(), threads)
+
+
+class Stats(object):
+    """XXX docstring"""
+
+    def __init__(self, data, threads):
+        self.data = data
+        self.threads = threads
+
+    def sort(self, crit="inlinetime"):
+        """XXX docstring"""
+        if crit not in profiler_entry.__dict__:
+            raise ValueError, "Can't sort by %s" % crit
+        self.data.sort(lambda b, a: cmp(getattr(a, crit),
+                                        getattr(b, crit)))
+        for e in self.data:
+            if e.calls:
+                e.calls.sort(lambda b, a: cmp(getattr(a, crit),
+                                              getattr(b, crit)))
+
+    def pprint(self, top=None, file=None):
+        """XXX docstring"""
+        if file is None:
+            file = sys.stdout
+        d = self.data
+        if top is not None:
+            d = d[:top]
+        cols = "% 12s %12s %11.4f %11.4f   %s\n"
+        hcols = "% 12s %12s %12s %12s %s\n"
+        cols2 = "+%12s %12s %11.4f %11.4f +  %s\n"
+        file.write(hcols % ("CallCount", "Recursive", "Total(ms)",
+                            "Inline(ms)", "module:lineno(function)"))
+        for e in d:
+            file.write(cols % (e.callcount, e.reccallcount, e.totaltime,
+                               e.inlinetime, label(e.code)))
+            if e.calls:
+                for se in e.calls:
+                    file.write(cols % ("+%s" % se.callcount, se.reccallcount,
+                                       se.totaltime, se.inlinetime,
+                                       "+%s" % label(se.code)))
+
+    def freeze(self):
+        """Replace all references to code objects with string
+        descriptions; this makes it possible to pickle the instance."""
+
+        # this code is probably rather ickier than it needs to be!
+        for i in range(len(self.data)):
+            e = self.data[i]
+            if not isinstance(e.code, str):
+                self.data[i] = type(e)((label(e.code),) + e[1:])
+            if e.calls:
+                for j in range(len(e.calls)):
+                    se = e.calls[j]
+                    if not isinstance(se.code, str):
+                        e.calls[j] = type(se)((label(se.code),) + se[1:])
+        for s in self.threads.values():
+            s.freeze()
+
+    def calltree(self, file):
+        """Output profiling data in calltree format (for KCacheGrind)."""
+        _CallTreeFilter(self.data).output(file)
+
+
+class _CallTreeFilter(object):
+
+    def __init__(self, data):
+        self.data = data
+        self.out_file = None
+
+    def output(self, out_file):
+        self.out_file = out_file        
+        print >> out_file, 'events: Ticks'
+        self._print_summary()
+        for entry in self.data:
+            self._entry(entry)
+
+    def _print_summary(self):
+        max_cost = 0
+        for entry in self.data:
+            totaltime = int(entry.totaltime * 1000)
+            max_cost = max(max_cost, totaltime)
+        print >> self.out_file, 'summary: %d' % (max_cost,)
+
+    def _entry(self, entry):
+        out_file = self.out_file
+        code = entry.code
+        inlinetime = int(entry.inlinetime * 1000)
+        #print >> out_file, 'ob=%s' % (code.co_filename,)
+        print >> out_file, 'fi=%s' % (code.co_filename,)
+        print >> out_file, 'fn=%s' % (label(code, True),)
+        print >> out_file, '%d %d' % (code.co_firstlineno, inlinetime)
+        # recursive calls are counted in entry.calls
+        if entry.calls:
+            calls = entry.calls
+        else:
+            calls = []
+        for subentry in calls:
+            self._subentry(code.co_firstlineno, subentry)
+        print >> out_file
+
+    def _subentry(self, lineno, subentry):
+        out_file = self.out_file
+        code = subentry.code
+        totaltime = int(subentry.totaltime * 1000)
+        #print >> out_file, 'cob=%s' % (code.co_filename,)
+        print >> out_file, 'cfn=%s' % (label(code, True),)
+        print >> out_file, 'cfi=%s' % (code.co_filename,)
+        print >> out_file, 'calls=%d %d' % (
+            subentry.callcount, code.co_firstlineno)
+        print >> out_file, '%d %d' % (lineno, totaltime)
+
+
+_fn2mod = {}
+
+def label(code, calltree=False):
+    if isinstance(code, str):
+        return code
+    try:
+        mname = _fn2mod[code.co_filename]
+    except KeyError:
+        for k, v in sys.modules.items():
+            if v is None:
+                continue
+            if getattr(v, '__file__', None) is None:
+                continue
+            if not isinstance(v.__file__, str):
+                continue
+            if v.__file__.startswith(code.co_filename):
+                mname = _fn2mod[code.co_filename] = k
+                break
+        else:
+            mname = _fn2mod[code.co_filename] = '<%s>'%code.co_filename
+    if calltree:
+        return '%s %s:%d' % (code.co_name, mname, code.co_firstlineno)
+    else:
+        return '%s:%d(%s)' % (mname, code.co_firstlineno, code.co_name)
+
+
+if __name__ == '__main__':
+    import os
+    sys.argv = sys.argv[1:]
+    if not sys.argv:
+        print >> sys.stderr, "usage: lsprof.py <script> <arguments...>"
+        sys.exit(2)
+    sys.path.insert(0, os.path.abspath(os.path.dirname(sys.argv[0])))
+    stats = profile(execfile, sys.argv[0], globals(), locals())
+    stats.sort()
+    stats.pprint()

=== modified file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2006-12-14 05:25:41 +0000
+++ loggerhead/static/css/style.css	2006-12-15 01:14:05 +0000
@@ -17,6 +17,10 @@
 	color: black;
 }
 
+img {
+	border: none;
+}
+
 h1 {
     color: #708a96;
 	font-weight: normal;
@@ -82,7 +86,7 @@
     font-size: smaller;
 }
 
-/* navigation button in the pages (the ones at the top left) */
+/* navigation button in the pages (the ones at the top left, and bottom) */
 .buttons {
 }
 
@@ -100,12 +104,16 @@
     color: blue;
 }
 
+.feed img {
+	vertical-align: text-top;
+}
+
 .rbuttons a {
     font-weight: normal;
     color: #000088;
     font-size: 12pt;
-    padding-right: 10px;
-    padding-left: 7px;
+    padding-right: 7px;
+    padding-left: 10px;
     border-left: 1px dotted #8cacbb;
     text-align: right;
     width: auto;
@@ -244,6 +252,12 @@
 
 /* ----- revision page ----- */
 
+div.links {
+	padding-top: 0.5em;
+	padding-left: 3em;
+	font-size: 50%;
+}
+
 .revision-info {
     border: none;
     font-size: smaller;
@@ -469,9 +483,3 @@
 .annotate th.text {
 	padding-left: 1em;
 }
-
-.annotate td.changed {
-	xxborder-top: 1px solid #8cacbb;
-}
-
-

=== added file 'loggerhead/static/images/feed-icon-16x16.gif'
Binary files loggerhead/static/images/feed-icon-16x16.gif and loggerhead/static/images/feed-icon-16x16.gif differ
=== modified file 'loggerhead/templates/changelog.kid'
--- loggerhead/templates/changelog.kid	2006-12-14 03:00:10 +0000
+++ loggerhead/templates/changelog.kid	2006-12-15 01:14:05 +0000
@@ -62,10 +62,10 @@
                     <td class="revision-number"> ${revlink_path(revid, start_revid, entry.revno, path)} </td>
                     <td class="expand-button">
                         <a href="javascript:displayDetails('${entry.revno}', 'none', '')" id="hide-${entry.revno}" class="show-button">
-                            <img src="${tg.url('/static/images/nav-small-down.gif')}" width="10" height="10" border="0" />
+                            <img src="${tg.url('/static/images/nav-small-down.gif')}" width="10" height="10" />
                         </a>
                         <a href="javascript:displayDetails('${entry.revno}', '', 'none')" id="show-${entry.revno}" class="hide-button">
-                        	<img src="${tg.url('/static/images/nav-small-right.gif')}" witdh="10" height="10" border="0" />
+                        	<img src="${tg.url('/static/images/nav-small-right.gif')}" witdh="10" height="10" />
                         </a>
                     </td>
 					<td class="summary"> ${revlink_path(entry.revid, start_revid, entry.short_comment, path)} </td>

=== modified file 'loggerhead/templates/master.kid'
--- loggerhead/templates/master.kid	2006-12-13 08:53:38 +0000
+++ loggerhead/templates/master.kid	2006-12-15 01:14:05 +0000
@@ -12,18 +12,22 @@
 
 <!-- !define common navbar -->
 <span py:def="navbar()">
-    <!-- !requires: ${navigation: revid, revlist, pagesize, buttons, scan_url}, ${history} -->
+    <!-- !requires: ${navigation: start_revid, revid, revlist, pagesize, buttons, scan_url}, ${history} -->
     <div class="navbar">
         <div class="bar">
             <table>
                 <tr><td>
                     <span class="buttons">
-                        <span py:for="label, url in navigation.buttons">
-                            <a href="${url}"> ${label} </a>
-                        </span>
+                        <!-- ! navbar buttons never change, from now on.  i decree it! -->
+                        <a href="${tg.url('/changes')}"> changes </a>
+                        <a href="${tg.url('/files')}"> files </a>
                     </span>
                 </td><td align="right" py:if="hasattr(navigation, 'revlist')">
+                        <span py:if="hasattr(navigation, 'feed')" class="rbuttons feed">
+                            <a href="${tg.url('/atom')}"><img src="/static/images/feed-icon-16x16.gif" /></a>
+                        </span>
                     <span class="navbuttons">
+                    	revisions:
                         <span py:for="label, l_title, l_revid in history.scan_range(navigation.revlist, navigation.revid, navigation.pagesize)">
                             <a py:if="l_revid" href="${tg.url([ navigation.scan_url, l_revid ], path=navigation.path, start_revid=navigation.start_revid)}" title="${l_title}"> ${label} </a>
                             <span py:if="not l_revid"> ${label} </span>
@@ -37,7 +41,7 @@
                 <tr>
                     <td> </td>
                     <td class="navposition" align="right" py:if="hasattr(navigation, 'revlist')">
-                        changes: ${len(navigation.revlist) - history.get_revid_sequence(navigation.revlist, navigation.revid)} / ${len(navigation.revlist)}
+                        viewing ${len(navigation.revlist) - history.get_revid_sequence(navigation.revlist, navigation.revid)} / ${len(navigation.revlist)}
                     </td>
                 </tr>
             </table>

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2006-12-14 05:25:41 +0000
+++ loggerhead/templates/revision.kid	2006-12-15 01:14:05 +0000
@@ -14,8 +14,14 @@
 
 ${navbar()}
 
-<h1> <span class="branch-name">${branch_name}</span> : revision ${change.revno} </h1>
+<h1> <span class="branch-name">${branch_name}</span> : revision ${change.revno}
 
+<div class="links">
+    <div> <b>&#8594;</b> <a href="%{tg.url([ '/files', revid ])}">browse files</a> </div>
+    <div> <b>&#8594;</b> <a href="%{tg.url('/changes', start_revid=revid)}">view branch changes</a> </div>
+</div>
+ </h1>
+ 
 <div class="revision-info">
     <table>
         <tr>
@@ -92,10 +98,10 @@
     <table>
         <tr>
         	<td class="buttons">
-            	<a py:if="prev_revid != revid" href="${tg.url([ '/changes', prev_revid ], start_revid=start_revid, path=path)}"> &lt;&lt; revision ${history.get_revno(prev_revid)} </a>
+            	<a py:if="prev_revid != revid" href="${tg.url([ '/changes', prev_revid ], start_revid=start_revid, path=path)}"> &lt; revision ${history.get_revno(prev_revid)} </a>
 	 		</td>
  			<td class="rbuttons" align="right">
-            	<a py:if="next_revid != revid" href="${tg.url([ '/changes', next_revid ], start_revid=start_revid, path=path)}"> revision ${history.get_revno(next_revid)} &gt;&gt; </a>
+            	<a py:if="next_revid != revid" href="${tg.url([ '/changes', next_revid ], start_revid=start_revid, path=path)}"> revision ${history.get_revno(next_revid)} &gt; </a>
  			</td>
  		</tr>
  	</table>

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2006-12-14 03:00:10 +0000
+++ loggerhead/util.py	2006-12-15 01:14:05 +0000
@@ -118,12 +118,12 @@
     return '%s at %s' % (username, domains[0])
 
     
-def triple_factors():
+def triple_factors(min_value=1):
     factors = (1, 3)
     index = 0
     n = 1
     while True:
-        if n >= 10:
+        if n >= min_value:
             yield n * factors[index]
         index += 1
         if index >= len(factors):
@@ -131,7 +131,7 @@
             n *= 10
 
 
-def scan_range(pos, max):
+def scan_range(pos, max, pagesize=1):
     """
     given a position in a maximum range, return a list of negative and positive
     jump factors for an hgweb-style triple-factor geometric scan.
@@ -143,7 +143,7 @@
     invent it. :)
     """
     out = []
-    for n in triple_factors():
+    for n in triple_factors(pagesize + 1):
         if n > max:
             return out
         if pos + n < max:

